/**************************************************************************//**
*   @file   mb_interrupts.h
*   @brief  Interrupts handling functions header file.
*   @author ATofan (alexandru.tofan@analog.com)
*
*******************************************************************************
* Copyright 2011(c) Analog Devices, Inc.
*
* All rights reserved.
*
* Redistribution and use in source and binary forms, with or without modification,
* are permitted provided that the following conditions are met:
*  - Redistributions of source code must retain the above copyright
*    notice, this list of conditions and the following disclaimer.
*  - Redistributions in binary form must reproduce the above copyright
*    notice, this list of conditions and the following disclaimer in
*    the documentation and/or other materials provided with the
*    distribution.
*  - Neither the name of Analog Devices, Inc. nor the names of its
*    contributors may be used to endorse or promote products derived
*    from this software without specific prior written permission.
*  - The use of this software may or may not infringe the patent rights
*    of one or more patent holders.  This license does not release you
*    from the requirement that you obtain separate licenses from these
*    patent holders to use this software.
*  - Use of the software either in source or binary form, must be run
*    on or directly connected to an Analog Devices Inc. component.
*
* THIS SOFTWARE IS PROVIDED BY ANALOG DEVICES "AS IS" AND ANY EXPRESS OR IMPLIED
* WARRANTIES, INCLUDING, BUT NOT LIMITED TO, NON-INFRINGEMENT, MERCHANTABILITY
* AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
* IN NO EVENT SHALL ANALOG DEVICES BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
* SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
* INTELLECTUAL PROPERTY RIGHTS, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
* LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
* ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
* (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
* SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*
*******************************************************************************
*   SVN Revision: $WCREV$
******************************************************************************/

#ifndef MB_INTERRUPTS_H_
#define MB_INTERRUPTS_H_

#include "xparameters.h"
#include "mb_interface.h"
#include "xintc_l.h"
#include "Xintc_l.h"

// Interrupt controller
#define INTC_BASEADDR			XPAR_INTC_0_BASEADDR
// UART
#define UART_BASEADDR			XPAR_RS232_UART_1_BASEADDR
#define UART_INTERRUPT			XPAR_MICROBLAZE_0_INTC_RS232_UART_1_INTERRUPT_INTR
#define UART_INTERRUPT_MASK		XPAR_RS232_UART_1_INTERRUPT_MASK
// I2S
#define I2S_BASEADDR			XPAR_AXI_I2S_INTR_ADI_0_BASEADDR
#define I2S_INTERRUPT			XPAR_MICROBLAZE_0_INTC_AXI_I2S_INTR_ADI_0_REQ_DATA_INTR_O_INTR
#define I2S_INTERRUPT_MASK		XPAR_AXI_I2S_INTR_ADI_0_REQ_DATA_INTR_O_MASK

void enableInterrupts(void);
void uartIntHandler(void);
void I2SIntHandler(void);

#endif /* MB_INTERRUPTS_H_ */
